
<p>Razmislite o sljedećem digitalnom sklopu. Sklop ima jedan ulaz: cijeli broj <i>x</i> te jedan izlaz: cijeli broj <i>y</i>. Sklop na ulaz može dobiti broj iz skupa {0, 1, 2, 3, 4, 5, 6, 7}. Sklop na izlazu <i>y</i> daje cijeli broj izračunat prema izrazu \(2 \cdot (x+1) - 1\).</p>

<p>S obzirom da na ulaz sklopa trebamo dovesti cijeli broj koji može poprimiti vrijednost od 0 do 7, broj ćemo kodirati prirodnim binarnim kodom s tri bita: <i>x</i><sub>2</sub>, <i>x</i><sub>1</sub> i <i>x</i><sub>0</sub>, pri čemu će <i>x</i><sub>2</sub> biti bit najveće težine. Primjerice, kada na ulaz sklopa želimo dovesti <i>x</i>=6, zapravo ćemo dovesti <i>x</i><sub>2</sub><i>x</i><sub>1</sub><i>x</i><sub>0</sub>=110, što je binarni kod broja 6. Izlaz ćemo definirati analogno. Najveći cijeli broj koji zadana funkcija generira dobiva se za ulaz \(x=7\) i iznosi \(y=15\). Za prikaz tog broja prirodnim binarnim kodom trebat ćemo četiri bita pa ćemo sklopu definirati četiri binarna izlaza: <i>y</i><sub>3</sub>, <i>y</i><sub>2</sub>, <i>y</i><sub>1</sub> i <i>y</i><sub>0</sub>. Sučelje ovakvog sklopa prikazano je na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(sklop6.svg)" alt="Prikaz sučelja digitalnog sklopa. Svi ulazi i izlazi su binarni podatci." border="0">
<figcaption>Prikaz sučelja zadanog digitalnog sklopa. Svi ulazi i izlazi su binarni podatci.</figcaption>
</figure>

   <div class="mlQuestionText">
    <p>Vaš je zadatak da popunite tablicu istinitosti koja odgovara Booleovoj funkciji koju ostvaruje opisani sklop. 
       Prvi dio tablice istinitosti koji navodi sve elemente domene već je popunjen. Vi trebate popuniti stupce 
       <i>y</i><sub>3</sub> , <i>y</i><sub>2</sub>, <i>y</i><sub>1</sub> i <i>y</i><sub>0</sub>
       prikazane tablice. Popunjavanje radite klikom miša na određenu ćeliju čime mijenjate upisanu vrijednost. 
       Kad ste gotovi, pritisnite gumb za nastavak.
    </p>

    <canvas id="myCanvas" width="600" height="290"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 3,
        outvars: 4,
        labels: ["x2","x1","x0","y3","y2","y1","y0"],
        //elems: [[0,0,0],[0,0,1],[0,1,0],[0,1,1],[1,0,0],[1,0,1],[1,1,0],[1,1,1]],
        //userInput: [[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1],[-1,-1,-1,-1]],
        hots: []
      };

      var konfiguracija = @#raw-text#(jsinitdata);
      state.elems = konfiguracija.elems;
      state.userInput = konfiguracija.userInput;

      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            if(h.active) {
              state.currentRow = h.row;
              var u = state.userInput[h.row][h.column];
              if(u==-1) { u = 0; } else { u = 1-u; }
              state.userInput[h.row][h.column] = u;
              draw(canvas, context, state);
              break;
            } else {
              state.currentRow = h.row;
              draw(canvas, context, state);
              break;
            }
          }
        }
      }, false);

      function draw(canvas, context, state) {
        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw circuit...

        var cloff = 100; var ctoff = 40; var cvertOut = 20; var cvertBetween = 50; var choriz = 70; var connector = 20;

        var cheightLeft = 2*cvertOut + (state.vars-1)*cvertBetween;
        var cheightRight = 2*cvertOut + (state.outvars-1)*cvertBetween;
        var cheight = Math.max(cheightLeft,cheightRight);

        var coffl = (cheight-cheightLeft)/2;
        var coffr = (cheight-cheightRight)/2;

        context.beginPath();
        context.strokeStyle = '#000000';
        for(var v = 0; v < state.vars; v++) {
          context.moveTo(cloff, ctoff+coffl+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+coffl+cvertOut+v*cvertBetween);
        }
        for(var v = 0; v < state.outvars; v++) {
          context.moveTo(cloff + connector + choriz, ctoff+coffr+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector + choriz + connector, ctoff+coffr+cvertOut+v*cvertBetween);
        }
        context.stroke();

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();


        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';
        context.textBaseline = 'middle';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.strokeText(state.labels[v], cloff + connector + 2, ctoff+coffl+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.strokeText(''+state.elems[state.currentRow][v], cloff - 2, ctoff+coffl+cvertOut+v*cvertBetween);
        }
        for(var v = 0; v < state.outvars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'right';
          context.strokeText(state.labels[state.labels.length-state.outvars+v], cloff + connector + choriz - 2, ctoff+coffr+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'left';
          context.strokeText(state.userInput[state.currentRow][v]==-1?'?' : ''+state.userInput[state.currentRow][v], cloff + connector + choriz + connector + 2, ctoff+coffr+cvertOut+v*cvertBetween);
        }

        // Draw table...

        var rh = 30; var toff = 10; var loff = 240; var cw = 50;

        context.beginPath();
        context.strokeStyle = '#000000';
        context.rect(0, 0, canvas.width, canvas.height);
        context.stroke();

        context.beginPath();
        context.rect(loff, toff, (state.vars+state.outvars)*cw, rh);
        context.fillStyle = '#cccccc';
        context.fill();

        context.beginPath();
        context.rect(loff, toff+(state.currentRow+1)*rh, (state.vars+state.outvars)*cw, rh);
        context.fillStyle = 'yellow';
        context.fill();

        context.beginPath();
        context.lineWidth = 1;
        for(var y = 0; y <= state.elems.length+1; y++) {
          context.moveTo(loff, y*rh+toff);
          context.lineTo(loff+(state.vars+state.outvars)*cw, y*rh+toff);
        }
        for(var x = 0; x <= state.vars+state.outvars+1; x++) {
          context.moveTo(loff+x*cw, toff);
          context.lineTo(loff+x*cw, (state.elems.length+1)*rh+toff);
        }
        context.strokeStyle = '#ff0000';
        context.stroke();

        var fontSize = 14;
        context.font = 'normal '+fontSize+'pt Calibri';
        context.textAlign = 'center';
        context.textBaseline = 'bottom';
        state.hots.length = 0;

        function handler(act,x,y,w,h,state,row,column) {
          this.active = act; this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row; this.column=column;
        }

        for(var y = 0; y < state.elems.length+1; y++) {
          for(var x = 0; x < state.vars+state.outvars; x++) {
            var txt = y==0 ? state.labels[x] : (x>=state.vars ? ''+state.userInput[y-1][x-state.vars] : ''+state.elems[y-1][x]);
            if(txt==-1) txt = "?";
            if(y>0 && x==(state.vars+state.outvars-1)) {
              for(var v = 0; v < state.outvars; v++) {
                state.hots.push(new handler(true,loff+(state.vars+v)*cw,y*rh+toff,cw,rh,state,y-1,v));
              }
              state.hots.push(new handler(false,loff,y*rh+toff,state.vars*cw,rh,state,y-1,-1));
            }
            context.strokeText(txt, loff+(x+0.5)*cw, (y+1)*rh+toff-(rh-fontSize)/4);
          }
        }

      }

      draw(canvas, context, state);

      function questionCollectUserData() {
        return {userInput: state.userInput};
      }
    </script>

   </div>
